/*
 * blanco Framework
 * Copyright (C) 2004-2005 IGA Tosiki
 * 
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 */
package blanco.plugin.soap.actions;

import java.io.File;
import java.io.InputStream;
import java.io.OutputStream;
import java.lang.reflect.InvocationTargetException;

import org.eclipse.core.resources.IFile;
import org.eclipse.core.resources.IFolder;
import org.eclipse.core.resources.IResource;
import org.eclipse.core.runtime.IProgressMonitor;
import org.eclipse.jface.dialogs.MessageDialog;
import org.eclipse.jface.operation.IRunnableWithProgress;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.ui.PlatformUI;

import blanco.commons.io.File2StreamWrapper;
import blanco.commons.util.BlancoNameUtil;
import blanco.doclisting.BlancoDocListingXml2CombinedXmlTelegram;
import blanco.doclisting.BlancoDocListingXml2CombinedXmlTelegramProcess;
import blanco.plugin.soap.BlancoSOAPPlugin;
import blanco.plugin.soap.editors.BlancoSOAPEditor;
import blanco.plugin.soap.editors.BlancoSOAPPluginUtil;
import blanco.wsdl.BlancoWsdlMeta2Xml;
import blanco.wsdl.BlancoWsdlXml2Wsdl;
import blanco.wsdl.BlancoWsdlXml2Xsd;
import blanco.xsd.BlancoXsdXsdValidator;

/**
 * d`Ed` (Excel) WSDLEXSD𐶐ANV
 * 
 * @author IGA Tosiki
 */
public class BlancoSOAPGenerateAction {
    /**
     * GUIfobOp̒ᑬ[hBʏfalseŉ^p܂B
     */
    private static final boolean IS_DEBUG_SLOW = false;

    /**
     * blancoSOAP\[XR[hs܂B
     * 
     * @param input
     * @return
     * @throws InvocationTargetException
     * @throws InterruptedException
     */
    public static final void processBlancoSOAP(final IFile ifile,
            final Shell shell, IProgressMonitor workbenchMonitor,
            final String metaDir, final String blancoWsdlDir,
            final boolean isGenerateXsdElementDeclaration)
            throws InvocationTargetException, InterruptedException {
        if (ifile.getProject().getFolder(metaDir).exists() == false) {
            MessageDialog.openWarning(shell, "\[XR[h", "^fBNg (" + metaDir
                    + ") ݂܂B𒆒f܂B");
            return;
        }

        // Eclipse 3.3 ΍: begin
        // workbenchMonitor𗘗p邱Ƃ~܂B
        // org.eclipse.swt.SWTException: Invalid thread access Ă܂܂B
        // Eclipse 3.3 ΍: end

        try {
            // PlatformUI.getWorkbench().getProgressService()LvƔfB
            PlatformUI.getWorkbench().getProgressService().busyCursorWhile(
                    new IRunnableWithProgress() {
                        public void run(IProgressMonitor monitor)
                                throws InvocationTargetException,
                                InterruptedException {
                            try {
                                monitor.beginTask("blancoSOAP\[XR[h", 10);

                                if (monitor.isCanceled()) {
                                    return;
                                }

                                monitor.subTask("fBNg: e|tH_̒");

                                // e|tH_U폜܂B
                                BlancoSOAPPluginUtil.deleteFolder(ifile,
                                        monitor, "tmp/soap/wsdl");
                                BlancoSOAPPluginUtil.createFolder(ifile,
                                        monitor, "tmp/soap/wsdl");
                                BlancoSOAPPluginUtil.createFolder(ifile,
                                        monitor, "tmp/soap/wsdl/tmp");
                                BlancoSOAPPluginUtil.createFolder(ifile,
                                        monitor, blancoWsdlDir);

                                final IFolder folderBlancoWsdl = BlancoSOAPPluginUtil
                                        .findFolder(ifile, monitor,
                                                blancoWsdlDir);
                                folderBlancoWsdl.refreshLocal(
                                        IResource.DEPTH_INFINITE, monitor);

                                final IFolder folderDirSoapWsdl2 = BlancoSOAPPluginUtil
                                        .findFolder(ifile, monitor,
                                                "tmp/soap/wsdl");
                                final IFolder folderDirSoapWsdlTmp = BlancoSOAPPluginUtil
                                        .findFolder(ifile, monitor,
                                                "tmp/soap/wsdl/tmp");
                                folderDirSoapWsdlTmp.refreshLocal(
                                        IResource.DEPTH_INFINITE, monitor);

                                final IFolder folderDirDoclisting = BlancoSOAPPluginUtil
                                        .findFolder(ifile, monitor,
                                                "tmp/doclisting");
                                folderDirDoclisting.refreshLocal(
                                        IResource.DEPTH_INFINITE, monitor);

                                if (monitor.isCanceled()) {
                                    return;
                                }

                                monitor
                                        .subTask(BlancoSOAPEditor.BLANCO_META_FILE_TELEGRAM
                                                + " (*.xls)܂");
                                monitor.worked(1);

                                final IFolder folderDirMetaDir = BlancoSOAPPluginUtil
                                        .findFolder(ifile, monitor, metaDir);
                                folderDirMetaDir.refreshLocal(
                                        IResource.DEPTH_INFINITE, monitor);
                                final IResource[] resourcesMetaFiles = folderDirMetaDir
                                        .members();
                                for (int index = 0; index < resourcesMetaFiles.length; index++) {
                                    if (monitor.isCanceled()) {
                                        return;
                                    }

                                    if (resourcesMetaFiles[index] instanceof IFile) {
                                        IFile fileLookMetaFile = (IFile) resourcesMetaFiles[index];
                                        if (fileLookMetaFile.getFileExtension()
                                                .equals("xls") == false) {
                                            // xlsȊO̊gq̃t@C̓XLbv܂B");
                                            continue;
                                        }

                                        final IFile fileTargetXml = folderDirSoapWsdlTmp
                                                .getFile(fileLookMetaFile
                                                        .getName()
                                                        + ".xml");
                                        monitor.subTask("^t@C: t@C["
                                                + fileLookMetaFile.getName()
                                                + "]܂ (" + (index + 1)
                                                + "/"
                                                + resourcesMetaFiles.length
                                                + ")");

                                        final InputStream inStream = fileLookMetaFile
                                                .getContents();
                                        try {
                                            new File2StreamWrapper(null,
                                                    fileTargetXml.getLocation()
                                                            .toFile()) {
                                                protected void process(
                                                        InputStream inStreamIgnore,
                                                        OutputStream outStream)
                                                        throws Exception {
                                                    new BlancoWsdlMeta2Xml()
                                                            .process(inStream,
                                                                    outStream);
                                                    outStream.flush();
                                                }
                                            }.run();
                                        } finally {
                                            // OōXg[͊Oŕ܂B
                                            inStream.close();
                                        }

                                        if (IS_DEBUG_SLOW) {
                                            Thread.sleep(1000);
                                        }
                                    }
                                }

                                if (monitor.isCanceled()) {
                                    return;
                                }

                                monitor.subTask("WSDL/XSD쐬");
                                monitor.worked(1);

                                // o͂ blanco.wsdltH_Ƃ܂B(̒l̓ftHgl̏ꍇ̗)
                                final File fileBlancoWsdl = folderBlancoWsdl
                                        .getLocation().toFile();

                                final BlancoWsdlXml2Wsdl xml2wsdl = new BlancoWsdlXml2Wsdl();
                                folderDirSoapWsdlTmp.refreshLocal(
                                        IResource.DEPTH_INFINITE, monitor);
                                final IResource[] resourcesXmlWsdlFiles = folderDirSoapWsdlTmp
                                        .members();
                                for (int index = 0; index < resourcesXmlWsdlFiles.length; index++) {
                                    if (monitor.isCanceled()) {
                                        return;
                                    }
                                    if (resourcesXmlWsdlFiles[index] instanceof IFile) {
                                        final IFile fileLookMetaWorkXml = (IFile) resourcesXmlWsdlFiles[index];
                                        if (fileLookMetaWorkXml
                                                .getFileExtension().equals(
                                                        "xml") == false) {
                                            // gqxmlȊÕt@C̓XLbv܂B
                                            continue;
                                        }

                                        monitor.subTask("WSDL/XSD쐬: t@C["
                                                + fileLookMetaWorkXml.getName()
                                                + "]܂ (" + (index + 1)
                                                + "/"
                                                + resourcesXmlWsdlFiles.length
                                                + ")");

                                        try {
                                            // WSDLXSDsKv܂B
                                            final BlancoWsdlXml2Xsd xml2xsd = new BlancoWsdlXml2Xsd();
                                            if (isGenerateXsdElementDeclaration) {
                                                xml2xsd
                                                        .setGenerateXsdElementDeclaration(true);
                                            }
                                            xml2xsd.process(fileLookMetaWorkXml
                                                    .getLocation().toFile(),
                                                    fileBlancoWsdl);

                                            // XSDŐꂽXSDt@CWSDLŗpĂ܂B
                                            xml2wsdl.parse(fileLookMetaWorkXml
                                                    .getLocation().toFile(),
                                                    fileBlancoWsdl);
                                        } catch (IllegalArgumentException ex) {
                                            throw new IllegalArgumentException(

                                                    "t@C["
                                                            + fileLookMetaWorkXml
                                                                    .getName()
                                                            + "]̏ɃG[܂B𒆒f܂B\n\n"
                                                            + ex.toString());
                                        }

                                        if (IS_DEBUG_SLOW) {
                                            Thread.sleep(1000);
                                        }
                                    }
                                }

                                xml2wsdl.generate(fileBlancoWsdl);

                                folderBlancoWsdl.refreshLocal(
                                        IResource.DEPTH_INFINITE, monitor);
                                final IResource[] resourcesXmlXsdFiles = folderBlancoWsdl
                                        .members();
                                for (int index = 0; index < resourcesXmlXsdFiles.length; index++) {
                                    if (monitor.isCanceled()) {
                                        return;
                                    }
                                    if (resourcesXmlXsdFiles[index] instanceof IFile) {
                                        final IFile fileLookMetaWorkXsd = (IFile) resourcesXmlXsdFiles[index];
                                        if (fileLookMetaWorkXsd
                                                .getFileExtension().equals(
                                                        "xsd") == false) {
                                            // gqxsdȊÕt@C̓XLbv܂B
                                            continue;
                                        }

                                        monitor.subTask("XSD`FbN: t@C["
                                                + fileLookMetaWorkXsd.getName()
                                                + "]܂ (" + (index + 1)
                                                + "/"
                                                + resourcesXmlXsdFiles.length
                                                + ")");

                                        try {
                                            // XSDt@C̑Ó؂s܂B
                                            final String fileNameFinal = BlancoNameUtil
                                                    .trimFileExtension(fileLookMetaWorkXsd
                                                            .getName());
                                            new File2StreamWrapper(
                                                    fileLookMetaWorkXsd
                                                            .getLocation()
                                                            .toFile(), null) {
                                                protected void process(
                                                        InputStream inStream,
                                                        OutputStream outStreamIgnore)
                                                        throws Exception {
                                                    new BlancoXsdXsdValidator()
                                                            .process(inStream,
                                                                    fileNameFinal);
                                                }
                                            }.run();
                                        } catch (IllegalArgumentException ex) {
                                            throw new IllegalArgumentException(

                                                    "t@C["
                                                            + fileLookMetaWorkXsd
                                                                    .getName()
                                                            + "]̏ɃG[܂B𒆒f܂B\n\n"
                                                            + ex.toString());
                                        }

                                        if (IS_DEBUG_SLOW) {
                                            Thread.sleep(1000);
                                        }
                                    }
                                }

                                if (monitor.isCanceled()) {
                                    return;
                                }

                                final File fileDoclistingInput = folderDirSoapWsdlTmp
                                        .getLocation().toFile();
                                final File fileDoclistingOutput = folderDirDoclisting
                                        .getLocation().toFile();

                                monitor
                                        .subTask("ꗗXV: d`Ed`̈ꗗ̂߂̒ԃt@CXVB");
                                new BlancoDocListingXml2CombinedXmlTelegramProcess()
                                        .process(fileDoclistingInput,
                                                fileDoclistingOutput);
                                new BlancoDocListingXml2CombinedXmlTelegram()
                                        .process(fileDoclistingInput,
                                                fileDoclistingOutput);

                                if (monitor.isCanceled()) {
                                    return;
                                }

                                monitor.subTask("tH_XV: WSDL^t@CEtH_XV");
                                monitor.worked(1);
                                folderBlancoWsdl.refreshLocal(
                                        IResource.DEPTH_INFINITE, monitor);

                                if (IS_DEBUG_SLOW) {
                                    Thread.sleep(1000);
                                }
                            } catch (Exception e) {
                                // ŏIhqC
                                e.printStackTrace();
                                throw new InvocationTargetException(e, e
                                        .toString());
                            } catch (Error e) {
                                // ŏIhqC
                                e.printStackTrace();
                                throw new InvocationTargetException(e, e
                                        .toString());
                            } finally {
                                // Ō̍Ōł doneƂ܂B
                                monitor.done();
                            }
                        }
                    });
        } catch (InvocationTargetException ex) {
            BlancoSOAPPlugin.log(ex);
            MessageDialog.openWarning(shell, "\[XR[h",
                    "O܂B𒆒f܂B\n" + ex.getCause().toString());
            ex.printStackTrace();
        } catch (InterruptedException ex) {
            MessageDialog.openWarning(shell, "\[XR[h",
                    "荞ݒfO܂B𒆒f܂B\n" + ex.toString());
            ex.printStackTrace();
        } catch (Exception ex) {
            MessageDialog.openWarning(shell, "\[XR[h",
                    "\ʗO܂B𒆒f܂B\n" + ex.toString());
            ex.printStackTrace();
        }
    }
}